#coding: utf-8
import time

from lib.testCase.FlvPressureTest import FlvPressureTest
import logging

from lib.testCase.PullStreamTest import PullStreamTest

logging.basicConfig(level = logging.INFO,format = '%(asctime)s - %(name)s - %(levelname)s - %(message)s')
logger = logging.getLogger(__name__)

###########################################
#       推流h264 和 aac 文件压力测试
###########################################
from lib.testCase.H264PresureTest import H264PresureTest


def h264FilePushTest():
    test = H264PresureTest()
    test.setHost("10.100.12.3")
    test.setPort(1078)
    test.setMobileStart(10000000000)
    test.setChannel(1)
    test.setTerNum(10)
    test.setSendDur(0.001)
    test.setIsOpenPullStream(0)                           # 设置是否开启拉流
    test.setIsShowFrame(0)
    test.setVideoPath("h264/bbb3.h264")
    test.setAudioPath("aac/bbb3.aac")
    test.start()


def getPressTestObj():
    test = FlvPressureTest()
    test.setHost("10.100.11.125")
    test.setPort(1078)
    test.setMobileStart(50000000000)                  # 开始的设备号 （累加）
    test.setChannel(1)                                # 设置频道号
    test.setTerNum(30)                                 # 要启动的推拉流线程
    test.setIsOpenPullStream(1)                       # 设置是否开启拉流
    test.setIsShowFrame(0)                            # 拉流是否显示预览画面     （压力测试都应该填：0）
    test.setSendDur(0.007)                            # 设置socket 发送数据间隔
    test.setFlvPath("flv/aaa3.flv")                   # 设置视频路劲
    test.start()
    return test

###########################################
#       推流flv文件压力测试
###########################################
def flvFilePushTest():
    isLoop = 0                                         # 是否循环压力测试  0： 不循环  1：循环
    loopTime = 1 * 60 * 60                             # 循环压力测试的时长
    test = getPressTestObj()
    logger.info("-----------------------------启动新一轮压力测试-----------------------------")
    threadInfo = test.getThreadInfo()
    threadInfoPull = test.getThreadInfoPull()
    logger.info("剩余推流线程：" + str(len(threadInfo["threadObj"])))
    logger.info("剩余拉流线程：" + str(len(threadInfoPull["threadObj"])))
    if isLoop == 0:
        while len(threadInfo["threadObj"]) != 0 or len(threadInfoPull["threadObj"]) != 0:
            time.sleep(5)
            logger.info("剩余推流线程：" + str(len(threadInfo["threadObj"])))
            logger.info("剩余拉流线程：" + str(len(threadInfoPull["threadObj"])))
            threadInfo = test.getThreadInfo()
            threadInfoPull = test.getThreadInfoPull()
    else:
        print(len(threadInfo["threadObj"]))
        print(len(threadInfoPull["threadObj"]))
        if len(threadInfo["threadObj"]) == 0 and len(threadInfoPull["threadObj"]) == 0:
            test = getPressTestObj()
            threadInfo = test.getThreadInfo()
            threadInfoPull = test.getThreadInfoPull()
        while len(threadInfo["threadObj"]) != 0 or len(threadInfoPull["threadObj"]) != 0:
            time.sleep(5)
            logger.info("剩余推流线程：" + str(len(threadInfo["threadObj"])))
            logger.info("剩余拉流线程：" + str(len(threadInfoPull["threadObj"])))
            threadInfo = test.getThreadInfo()
            threadInfoPull = test.getThreadInfoPull()
        time.sleep(30)
        flvFilePushTest()
    logger.info("压力测试结束!!!!!!")


###########################################
#       对单个源进行拉流压力测试
###########################################
def pullSingleSourcePressureTest():
    obj = PullStreamTest()
    obj.setPlayUrl("http://10.100.11.125:8085/live?port=1985&app=vandyo&stream=110000000000-1-336026784011127677")
    obj.setTerNum(30)
    obj.start()
    pullInfos = obj.getThreadInfoPull()
    while len(pullInfos["threadObj"]) > 0:
        time.sleep(5)
        logger.info("剩余拉流线程：" + str(len(pullInfos["threadObj"])))
        pullInfos = obj.getThreadInfoPull()
    print("")
    print("所有拉流结束。。。。。。")


if __name__ == "__main__":
    flvFilePushTest()                            # 推拉流压力测试 （可关闭拉流）
    # h264FilePushTest()                           # H264推流压力测试
    # pullSingleSourcePressureTest()               # 对单个源进行拉流压力测试
